import { M as MaybeReferenceRef, a as MaybeFloatingRef, b as MaybeRef, U as UseFloatingOptions, c as UseFloatingReturn } from './useAutoUpdate-b2e62d09.js';
export { F as FloatingType, a as MaybeFloatingRef, M as MaybeReferenceRef, R as ReferenceType, d as UseAutoUpdateOptions, e as UseFloatingData, U as UseFloatingOptions, c as UseFloatingReturn, u as useAutoUpdate } from './useAutoUpdate-b2e62d09.js';
import { Ref, WatchOptions, UnwrapRef } from 'vue-demi';
export { Middleware, MiddlewareData, Placement, Strategy } from '@floating-ui/core';
export { VirtualElement } from '@floating-ui/dom';

/**
 * Uue hooks based on `computePosition`.
 * @see https://floating-ui.com/docs/computePosition
 */
declare function useFloating(referenceRef: MaybeReferenceRef, floatingRef: MaybeFloatingRef, options?: MaybeRef<UseFloatingOptions>): UseFloatingReturn;

declare function useFloatingOptionsChange(options: Ref<UseFloatingOptions>, onChange: (options: UseFloatingOptions) => void, watchOptions?: WatchOptions): {
    stop: () => void;
    mesure: () => void;
};

declare type CreateEffect = () => (() => void) | void;
declare const createEmptyEffect: CreateEffect;
interface UseManualEffectReturn {
    clear: () => void;
    reset: (effect?: () => void) => void;
    mesure: () => void;
}
declare function useManualEffect(createEffect?: CreateEffect, immediate?: boolean): UseManualEffectReturn;

declare type ConditionHandler<T extends any[]> = (qualifys?: NonNullables<UnwrapRefs<T>>) => void;
declare type Predicate<T = any> = (item: T) => boolean;
interface UseQualifiedRefsReturn {
    detect: () => void;
    mesure: () => void;
    stop: () => void;
}
declare function useQualifiedRefs<T extends any[]>(refs: MaybeRef<T>, handler: ConditionHandler<T>, options?: WatchOptions): UseQualifiedRefsReturn;
declare function useQualifiedRefs<T extends any[]>(refs: MaybeRef<T>, handler: ConditionHandler<T>, predicate?: Predicate<T[number]>, options?: WatchOptions): UseQualifiedRefsReturn;
declare type UnwrapRefs<T> = {
    [Key in keyof T]: UnwrapRef<T[Key]>;
};
declare type NonNullables<T> = {
    [Key in keyof T]: NonNullable<T[Key]>;
};

export { ConditionHandler, CreateEffect, Predicate, UseManualEffectReturn, UseQualifiedRefsReturn, createEmptyEffect, useFloating, useFloatingOptionsChange, useManualEffect, useQualifiedRefs };
